<?php
/*
 osCommRes, Services Online 
http://www.oscommres.com 
Copyright (c) 2005 osCommRes 

Freeway eCommerce 
http://www.zac-ware.com/freeway 
Copyright (c) 2007 ZacWare 

Released under the GNU General Public License 
*/
// Check to ensure this file is included in Freeway!
defined('_FEXEC') or die();
  class virtualpay {
    var $code, $title, $description, $enabled, $states;

// class constructor
	function virtualpay() {
		
		global $order;
		$this->code = 'virtualpay';
		$name = "VirtualPay";
		$image = "";
		if(MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME != "MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME")$name = MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME;
		if(MODULE_PAYMENT_VIRTUALPAY_IMAGE != "MODULE_PAYMENT_VIRTUALPAY_IMAGE")$image = MODULE_PAYMENT_VIRTUALPAY_IMAGE;
		if($image != "" && file_exists("../" . DIR_WS_IMAGES . $image)){
			$image = '<img src="'. HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . $image . '" width="103" height="33">';
		}else{
			$image_array = array('.gif','.jpg','.jpeg','.png');
			$image_check = true;
			for($i=0;$i<sizeof($image_array);$i++){
				if($image_check && $image != "" && file_exists(DIR_WS_IMAGES . $image . $image_array[$i])){
					$image = '<img src="'. HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . $image . $image_array[$i] . '" width="103" height="33">';
					$image_check = false;
				}
			}
			if($image_check)$image = "";
		}
		define('MODULE_PAYMENT_VIRTUALPAY_TEXT_TITLE', $name . '&nbsp;&nbsp;' . $image);
		define('MODULE_PAYMENT_VIRTUALPAY_TEXT_TEXT_TITLE', $name);
		$this->title = MODULE_PAYMENT_VIRTUALPAY_TEXT_TITLE;
		$this->text_title = MODULE_PAYMENT_VIRTUALPAY_TEXT_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_VIRTUALPAY_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_VIRTUALPAY_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_VIRTUALPAY_STATUS == 'True') ? true : false);
		
		if ((int)MODULE_PAYMENT_VIRTUALPAY_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_VIRTUALPAY_ORDER_STATUS_ID;
		}
		
		if (is_object($order)) $this->update_status();
		
		$this->form_action_url = ((MODULE_PAYMENT_VIRTUALPAY_TESTMODE == 'Test') ? 'https://secure.paymentclearing.com/cgi-bin/rc/ord.cgi' : 'https://secure.paymentclearing.com/cgi-bin/rc/ord.cgi');
	}

// class methods
    function update_status() {
      global $order;

  	  tep_check_module_status($this,MODULE_PAYMENT_VIRTUALPAY_ZONE,trim(MODULE_PAYMENT_VIRTUALPAY_EXCEPT_ZONE),trim(MODULE_PAYMENT_VIRTUALPAY_EXCEPT_COUNTRY));	
	 /* $except_zone_list=trim(MODULE_PAYMENT_VIRTUALPAY_EXCEPT_ZONE);
	  $except_county_list=trim(MODULE_PAYMENT_VIRTUALPAY_EXCEPT_COUNTRY);
	  //first filter the exception list
	  if ( ($this->enabled == true) && ($except_zone_list!='' || $except_country_list!='')) {
	  	$add_option='';
		if ($except_zone_list!='') $add_option.=" geo_zone_id in(" . $except_zone_list . ") ";
		if ($except_country_list!='') {
			if ($add_option!='') $add_option.=' or ';
			$add_option.=" zone_country_id in(" . $except_country_list . ") ";
		}
		$check_query=tep_db_query("SELECT zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where  (" . $add_option. ") and zone_country_id='" . $order->billing['country']['id'] . "' and (zone_id is null or zone_id = '0' or zone_id ='" . $order->billing['zone_id'] ."');");
		if (tep_db_num_rows($check_query)>0){
			$this->enabled=false;
		}
	  }
	  if ( ($this->enabled == true) && (MODULE_PAYMENT_VIRTUALPAY_ZONE!='') ) {
        $check_flag = false;
		$virtualpay_zone=MODULE_PAYMENT_VIRTUALPAY_ZONE!=""?MODULE_PAYMENT_VIRTUALPAY_ZONE:'';
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id in(" . $virtualpay_zone . ") and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      } */
    }

    function javascript_validation() {
      $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '    if (cc_owner.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_VIRTUALPAY_TEXT_JS_CC_OWNER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    if (cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_VIRTUALPAY_TEXT_JS_CC_NUMBER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '  }' . "\n";

      return $js;
    }

    function selection() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' =>sprintf('%02d', $i)); //strftime('%B',mktime(0,0,0,$i,1,2000))
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }
      
      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_VIRTUALPAY_TEXT_CREDIT_CARD_NUMBER,
                                                'field' => tep_draw_input_field('ccnum')),
                   	                      array('title' => MODULE_PAYMENT_VIRTUALPAY_TEXT_CREDIT_CARD_EXPIRES,
                                                'field' => tep_draw_pull_down_menu('ccmo', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('ccyr', $expires_year))));

      	return $selection;
    }

    function pre_confirmation_check() {
      global $HTTP_POST_VARS,$HTTP_SESSION_VARS;

      include(DIR_WS_CLASSES . 'cc_validation.php');

      $cc_validation = new cc_validation();
      $result = $cc_validation->validate($HTTP_POST_VARS['ccnum'], $HTTP_POST_VARS['ccmo'], $HTTP_POST_VARS['ccyr']);

      $error = '';
      switch ($result) {
        case -1:
          $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
          break;
        case -2:
        case -3:
        case -4:
          $error = TEXT_CCVAL_ERROR_INVALID_DATE;
          break;
        case false:
          $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
          break;
      }

      if ( ($result == false) || ($result < 1) ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) . '&virtualpay_cc_owner=' . urlencode($order->billing['firstname'].' '. $order->billing['lastname'] ) . '&virtualpay_cc_expires_month=' . $HTTP_POST_VARS['ccmo'] . '&securepay_cc_expires_year=' . $HTTP_POST_VARS['ccyr'];
		
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->cc_card_owner = $order->billing['firstname'].' '.$order->billing['lastname']; 
      $this->cc_card_number = $cc_validation->cc_number;
      $this->cc_expiry_month = $cc_validation->cc_expiry_month;
      $this->cc_expiry_year = $cc_validation->cc_expiry_year; 
    }

    function confirmation() {
      global $HTTP_POST_VARS;

      $confirmation = array('title' => $this->title,
                            'fields' => array(array('title' => MODULE_PAYMENT_VIRTUALPAY_TEXT_CREDIT_CARD_NUMBER,
                                                    'field' => substr($this->cc_card_number, 0, 4) . str_repeat('X', (strlen($this->cc_card_number) - 8)) . substr($this->cc_card_number, -4)),
                                              array('title' => MODULE_PAYMENT_VIRTUALPAY_TEXT_CREDIT_CARD_EXPIRES,
                                                    'field' => strftime('%B, %Y', mktime(0,0,0,$HTTP_POST_VARS['ccmo'], 1, '20' . $HTTP_POST_VARS['ccyr'])))));

      return $confirmation;
    }

    function process_button() {
      global $HTTP_SERVER_VARS, $order, $customer_id;

      $process_button_string = 	tep_draw_hidden_field('mername', STORE_NAME) .
								tep_draw_hidden_field('acceptcards', '1') .
								tep_draw_hidden_field('acceptchecks', '0') .
								tep_draw_hidden_field('accepteft', '0') .
								tep_draw_hidden_field('altaddr', '0') .
								tep_draw_hidden_field('nonum', '1') .
								tep_draw_hidden_field('passback',tep_session_name()).
								tep_draw_hidden_field('vendor_id', MODULE_PAYMENT_VIRTUALPAY_VENDOR_ID) .
								tep_draw_hidden_field('ccnum', $this->cc_card_number) .
								tep_draw_hidden_field('ccmo', $this->cc_expiry_month) .
								tep_draw_hidden_field('ccyr', $this->cc_expiry_year) .
								tep_draw_hidden_field('home_page',$server_path).
								tep_draw_hidden_field('ret_mode','post').
								tep_draw_hidden_field('post_back_on_error',1) .
								'<input type="hidden" name="ret_addr" value="'.tep_href_link(FILENAME_CREATE_ORDER_NEW,'','SSL', false).'">'.
								tep_draw_hidden_field('first_name',$order->billing['firstname']).
								tep_draw_hidden_field('last_name',$order->billing['lastname']).
								tep_draw_hidden_field('address',$order->billing['street_address'] .' ' . $order->billing['suburb']).
								tep_draw_hidden_field('city',$order->billing['city']).	                                                           
								tep_draw_hidden_field('state',$order->billing['state']).                               	
								tep_draw_hidden_field('zip',$order->billing['postcode']).
								tep_draw_hidden_field('country',tep_get_country_name($order->billing['country_id'])).
								tep_draw_hidden_field('phone',$order->customer['telephone']).
								tep_draw_hidden_field('email',$order->customer['email_address']);
     
	  $process_button_string .= tep_draw_hidden_field('1_desc', STORE_NAME . ' Order Total') .
                                tep_draw_hidden_field('1_cost', number_format($order->info['total'], 2, '.', '')) .
                                tep_draw_hidden_field('1_qty', '1'); // *_anything showaddr
								
      $process_button_string .= tep_draw_hidden_field(tep_session_name(), tep_session_id());
	  
      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $msg = "";
      if (stripslashes(urldecode($HTTP_GET_VARS['response_text'])) != "")
        $msg = stripslashes(urldecode($HTTP_GET_VARS['response_text']));
      else if (stripslashes(urldecode($HTTP_GET_VARS['error'])) != "") 
        $msg = stripslashes(urldecode($HTTP_GET_VARS['error']));
      $error = array('title' => MODULE_PAYMENT_VIRTUALPAY_TEXT_ERROR,
                     'error' => urldecode($msg));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_VIRTUALPAY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable VirtualPay', 'MODULE_PAYMENT_VIRTUALPAY_STATUS', 'True', 'Do you want to accept VirtualPay payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_VIRTUALPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Exclude these Countries', 'MODULE_PAYMENT_VIRTUALPAY_EXCEPT_COUNTRY', '', 'If countries are selected, disable this payment method for that countries.', '6', '3', 'tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_VIRTUALPAY_ZONE,', 'tep_get_zone_except_country', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Exclude these Zones', 'MODULE_PAYMENT_VIRTUALPAY_EXCEPT_ZONE', '', 'If a zone is selected, disable this payment method for that zone.', '6', '4', 'tep_cfg_pull_down_zone_classes(','tep_get_zone_class_title', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Vendor ID', 'MODULE_PAYMENT_VIRTUALPAY_VENDOR_ID', 'sec0001', 'The vendor id used for the VirtualPay service', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_VIRTUALPAY_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', '6', 'tep_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_VIRTUALPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '7', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_VIRTUALPAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Display Name', 'MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME', 'VirtualPay', 'Set the Display name to payment module', '6', '9', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Image', 'MODULE_PAYMENT_VIRTUALPAY_IMAGE', 'virtualpay', 'Set the Image of payment module', '6', '10', 'tep_cfg_file_field(', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_VIRTUALPAY_STATUS', 'MODULE_PAYMENT_VIRTUALPAY_ZONE','MODULE_PAYMENT_VIRTUALPAY_EXCEPT_ZONE', 'MODULE_PAYMENT_VIRTUALPAY_EXCEPT_COUNTRY', 'MODULE_PAYMENT_VIRTUALPAY_VENDOR_ID ', 'MODULE_PAYMENT_VIRTUALPAY_TESTMODE', 'MODULE_PAYMENT_VIRTUALPAY_SORT_ORDER', 'MODULE_PAYMENT_VIRTUALPAY_ORDER_STATUS_ID','MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME','MODULE_PAYMENT_VIRTUALPAY_IMAGE');
    }
  }
?>
